# Fractals
`2021-05-26`
This page is a collection of fractal renderers I made in JS for a school assignment back in 2020.
This is the *only* JS on this website.

## Tree fractal
The splitting angle is defined by the mouses x position. The number of iterations is set in the first input field (default is 12). Each branch is slightly smaller than its parent, the factor is the second input field. Click the canvas to pause/resume the image.
<div class="demo-render" id="fractal-tree">
<canvas></canvas>
<div class="controlbar">
<input type="number" min=6 max=15 value=12 onchange="fractalTree.setIter(value)">
<input type="number" min=0.65 max=1 step=0.025 value=0.75 onchange="fractalTree.setMod(value)">
</div>
</div>

## Mandelbrot set
[Wikipedia page](https://en.wikipedia.org/wiki/Mandelbrot_set)
You can click to zoom and set the iteration count in the input field.
<div class="demo-render" id="mandelbrot">
<canvas></canvas>
<div class="controlbar">
<button type="button" onclick="mandelbrot.reset()">Reset</button>
<input type="number" min=1 max=256 value=48 onchange="mandelbrot.setIter(value)">
</div>
</div>

## Multibrot set
[Wikipedia page](https://en.wikipedia.org/wiki/Multibrot_set)
You can click to zoom and set the iteration count in the input field. The second input controls the exponent.

This is quite slow to render.
<div class="demo-render" id="multibrot">
<canvas></canvas>
<div class="controlbar">
<button type="button" onclick="multibrot.reset()">Render</button>
<input type="number" min=1 max=256 value=48 onchange="multibrot.setIter(value)">
<input type="number" min=0 max=32 step=0.1 value=4 onchange="multibrot.setPower(value)">
</div>
</div>

## Interactive Julia set
[Wikipedia page](https://en.wikipedia.org/wiki/Julia_set)
You can set the iteration count in the input field.
<div class="demo-render" id="julia-set">
<canvas></canvas>
<div class="controlbar">
<button type="button" onclick="juliaSet.reset()">Reset</button>
<input type="number" min=8 max=1000 value=80 step=8 onchange="juliaSet.setIter(value)">
</div>
</div>

<script src="/old-projects/fractals.js"></script>
